diff -Npur gnumach.old/ipc/ipc_kmsg.c gnumach.new/ipc/ipc_kmsg.c
--- gnumach.old/ipc/ipc_kmsg.c	2006-03-20 08:31:36.000000000 -0300
+++ gnumach.new/ipc/ipc_kmsg.c	2006-04-05 13:29:14.000000000 -0300
@@ -35,7 +35,6 @@
  */
 
 #include <cpus.h>
-#include <mach_ipc_compat.h>
 
 #include <mach/boolean.h>
 #include <mach/kern_return.h>
@@ -651,13 +650,6 @@ ipc_kmsg_put_to_kernel(
  *		notification would be sent to the named receive right,
  *		then it isn't sent and the send-once right for the notify
  *		port is quietly destroyed.
- *
- *		[MACH_IPC_COMPAT] There is an atomicity problem if the
- *		reply port is a compat entry and dies at an inopportune
- *		time.  This doesn't have any serious consequences
- *		(an observant user task might conceivably notice that
- *		the destination and reply ports were handled inconsistently),
- *		only happens in compat mode, and is extremely unlikely.
  *	Conditions:
  *		Nothing locked.
  *	Returns:
@@ -1225,27 +1217,7 @@ ipc_kmsg_copyin_header(msg, space, notif
 		kr = ipc_right_copyin(space, reply_name, reply_entry,
 				      reply_type, TRUE,
 				      &reply_port, &reply_soright);
-#if	MACH_IPC_COMPAT
-		if (kr != KERN_SUCCESS) {
-			assert(kr == KERN_INVALID_NAME);
-
-			/*
-			 *	Oops.  This must have been a compat entry
-			 *	and the port died after the check above.
-			 *	We should back out the copyin of dest_port,
-			 *	and report MACH_SEND_INVALID_REPLY, but
-			 *	if dest_port is alive we can't always do that.
-			 *	Punt and pretend we got IO_DEAD, skipping
-			 *	further hairy atomicity problems.
-			 */
-
-			reply_port = IO_DEAD;
-			reply_soright = IP_NULL;
-			goto skip_reply_checks;
-		}
-#else	/* MACH_IPC_COMPAT */
 		assert(kr == KERN_SUCCESS);
-#endif	/* MACH_IPC_COMPAT */
 
 		if ((saved_reply != IP_NULL) && (reply_port == IO_DEAD)) {
 			ipc_port_t dest = (ipc_port_t) dest_port;
@@ -1306,15 +1278,6 @@ ipc_kmsg_copyin_header(msg, space, notif
 		if (IE_BITS_TYPE(reply_entry->ie_bits) == MACH_PORT_TYPE_NONE)
 			ipc_entry_dealloc(space, reply_name, reply_entry);
 
-#if	MACH_IPC_COMPAT
-	    skip_reply_checks:
-		/*
-		 *	We jump here if the reply entry was a compat entry
-		 *	and the port died on us.  In this case, the copyin
-		 *	code already deallocated reply_entry.
-		 */
-#endif	/* MACH_IPC_COMPAT */
-
 		if (IE_BITS_TYPE(dest_entry->ie_bits) == MACH_PORT_TYPE_NONE)
 			ipc_entry_dealloc(space, dest_name, dest_entry);
 
@@ -2686,464 +2649,6 @@ ipc_kmsg_copyout_dest(kmsg, space)
 	}
 }
 
-#if	MACH_IPC_COMPAT
-
-/*
- *	Routine:	ipc_kmsg_copyin_compat
- *	Purpose:
- *		"Copy-in" port rights and out-of-line memory
- *		in the message.
- *
- *		In all failure cases, the message is left holding
- *		no rights or memory.  However, the message buffer
- *		is not deallocated.  If successful, the message
- *		contains a valid destination port.
- *	Conditions:
- *		Nothing locked.
- *	Returns:
- *		MACH_MSG_SUCCESS	Successful copyin.
- *		MACH_SEND_INVALID_DEST	Can't copyin destination port.
- *		MACH_SEND_INVALID_REPLY	Can't copyin reply port.
- *		MACH_SEND_INVALID_MEMORY	Can't grab out-of-line memory.
- *		MACH_SEND_INVALID_RIGHT	Can't copyin port right in body.
- *		MACH_SEND_INVALID_TYPE	Bad type specification.
- *		MACH_SEND_MSG_TOO_SMALL	Body is too small for types/data.
- */
-
-mach_msg_return_t
-ipc_kmsg_copyin_compat(kmsg, space, map)
-	ipc_kmsg_t kmsg;
-	ipc_space_t space;
-	vm_map_t map;
-{
-	msg_header_t msg;
-	mach_port_t dest_name;
-	mach_port_t reply_name;
-	ipc_object_t dest, reply;
-	mach_msg_type_name_t dest_type, reply_type;
-	vm_offset_t saddr, eaddr;
-	boolean_t complex;
-	kern_return_t kr;
-	boolean_t use_page_lists, steal_pages;
-
-	msg = * (msg_header_t *) &kmsg->ikm_header;
-	dest_name = (mach_port_t) msg.msg_remote_port;
-	reply_name = (mach_port_t) msg.msg_local_port;
-
-	/* translate the destination and reply ports */
-
-	kr = ipc_object_copyin_header(space, dest_name, &dest, &dest_type);
-	if (kr != KERN_SUCCESS)
-		return MACH_SEND_INVALID_DEST;
-
-	if (reply_name == MACH_PORT_NULL) {
-		reply = IO_NULL;
-		reply_type = 0;
-	} else {
-		kr = ipc_object_copyin_header(space, reply_name,
-					      &reply, &reply_type);
-		if (kr != KERN_SUCCESS) {
-			ipc_object_destroy(dest, dest_type);
-			return MACH_SEND_INVALID_REPLY;
-		}
-	}
-
-	kmsg->ikm_header.msgh_bits = MACH_MSGH_BITS(dest_type, reply_type);
-	kmsg->ikm_header.msgh_size = (mach_msg_size_t) msg.msg_size;
-	kmsg->ikm_header.msgh_remote_port = (mach_port_t) dest;
-	kmsg->ikm_header.msgh_local_port = (mach_port_t) reply;
-	kmsg->ikm_header.msgh_seqno = (mach_msg_kind_t) msg.msg_type;
-	kmsg->ikm_header.msgh_id = (mach_msg_id_t) msg.msg_id;
-
-	if (msg.msg_simple)
-		return MACH_MSG_SUCCESS;
-
-	complex = FALSE;
-	use_page_lists = ipc_kobject_vm_page_list(ip_kotype((ipc_port_t)dest));
-	steal_pages = ipc_kobject_vm_page_steal(ip_kotype((ipc_port_t)dest));
-
-	saddr = (vm_offset_t) (&kmsg->ikm_header + 1);
-	eaddr = (vm_offset_t) &kmsg->ikm_header + kmsg->ikm_header.msgh_size;
-
-	while (saddr < eaddr) {
-		vm_offset_t taddr = saddr;
-		mach_msg_type_long_t *type;
-		mach_msg_type_name_t name;
-		mach_msg_type_size_t size;
-		mach_msg_type_number_t number;
-		boolean_t is_inline, longform, dealloc, is_port;
-		vm_offset_t data;
-		vm_size_t length;
-
-		type = (mach_msg_type_long_t *) saddr;
-
-		if (((eaddr - saddr) < sizeof(mach_msg_type_t)) ||
-		    ((longform = ((mach_msg_type_t*)type)->msgt_longform) &&
-		     ((eaddr - saddr) < sizeof(mach_msg_type_long_t)))) {
-			ipc_kmsg_clean_partial(kmsg, taddr, FALSE, 0);
-			return MACH_SEND_MSG_TOO_SMALL;
-		}
-
-		is_inline = ((mach_msg_type_t*)type)->msgt_inline;
-		dealloc = ((mach_msg_type_t*)type)->msgt_deallocate;
-		if (longform) {
-			/* This must be aligned */
-			if ((sizeof(natural_t) > sizeof(mach_msg_type_t)) &&
-			    (is_misaligned(type))) {
-				saddr = ptr_align(saddr);
-				continue;
-			}
-			name = type->msgtl_name;
-			size = type->msgtl_size;
-			number = type->msgtl_number;
-			saddr += sizeof(mach_msg_type_long_t);
-		} else {
-			name = ((mach_msg_type_t*)type)->msgt_name;
-			size = ((mach_msg_type_t*)type)->msgt_size;
-			number = ((mach_msg_type_t*)type)->msgt_number;
-			saddr += sizeof(mach_msg_type_t);
-		}
-
-		is_port = MSG_TYPE_PORT_ANY(name);
-
-		if (is_port && (size != PORT_T_SIZE_IN_BITS)) {
-			ipc_kmsg_clean_partial(kmsg, taddr, FALSE, 0);
-			return MACH_SEND_INVALID_TYPE;
-		}
-
-		/*
-		 *	New IPC says these should be zero, but old IPC
-		 *	tasks often leave them with random values.  So
-		 *	we have to clear them.
-		 */
-
-		((mach_msg_type_t*)type)->msgt_unused = 0;
-		if (longform) {
-			type->msgtl_header.msgt_name = 0;
-			type->msgtl_header.msgt_size = 0;
-			type->msgtl_header.msgt_number = 0;
-		}
-
-		/* padding (ptrs and ports) ? */
-		if ((sizeof(natural_t) > sizeof(mach_msg_type_t)) &&
-		    ((size >> 3) == sizeof(natural_t)))
-			saddr = ptr_align(saddr);
-
-		/* calculate length of data in bytes, rounding up */
-
-		length = ((number * size) + 7) >> 3;
-
-		if (is_inline) {
-			vm_size_t amount;
-
-			/* inline data sizes round up to int boundaries */
-
-			amount = (length + 3) &~ 3;
-			if ((eaddr - saddr) < amount) {
-				ipc_kmsg_clean_partial(kmsg, taddr, FALSE, 0);
-				return MACH_SEND_MSG_TOO_SMALL;
-			}
-
-			data = saddr;
-			saddr += amount;
-		} else {
-			vm_offset_t addr;
-
-			if ((eaddr - saddr) < sizeof(vm_offset_t)) {
-				ipc_kmsg_clean_partial(kmsg, taddr, FALSE, 0);
-				return MACH_SEND_MSG_TOO_SMALL;
-			}
-
-			/* grab the out-of-line data */
-
-			addr = * (vm_offset_t *) saddr;
-
-			if (length == 0)
-				data = 0;
-			else if (is_port) {
-				data = kalloc(length);
-				if (data == 0)
-					goto invalid_memory;
-
-				if (copyinmap(map, (char *) addr,
-					      (char *) data, length) ||
-				    (dealloc &&
-				     (vm_deallocate(map, addr, length) !=
-							KERN_SUCCESS))) {
-					kfree(data, length);
-					goto invalid_memory;
-				}
-			} else {
-				vm_map_copy_t copy;
-
-		      		if (use_page_lists) {
-					kr = vm_map_copyin_page_list(map,
-				        	addr, length, dealloc,
-						steal_pages, &copy, FALSE);
-				} else {
-					kr = vm_map_copyin(map, addr, length,
-							   dealloc,
-							   &copy);
-				}
-				if (kr != KERN_SUCCESS) {
-				    invalid_memory:
-					ipc_kmsg_clean_partial(kmsg, taddr,
-							       FALSE, 0);
-					return MACH_SEND_INVALID_MEMORY;
-				}
-
-				data = (vm_offset_t) copy;
-			}
-
-			* (vm_offset_t *) saddr = data;
-			saddr += sizeof(vm_offset_t);
-			complex = TRUE;
-		}
-
-		if (is_port) {
-			mach_msg_type_name_t newname =
-					ipc_object_copyin_type(name);
-			ipc_object_t *objects = (ipc_object_t *) data;
-			mach_msg_type_number_t i;
-
-			if (longform)
-				type->msgtl_name = newname;
-			else
-				((mach_msg_type_t*)type)->msgt_name = newname;
-
-			for (i = 0; i < number; i++) {
-				mach_port_t port = (mach_port_t) objects[i];
-				ipc_object_t object;
-
-				if (!MACH_PORT_VALID(port))
-					continue;
-
-				kr = ipc_object_copyin_compat(space, port,
-						name, dealloc, &object);
-				if (kr != KERN_SUCCESS) {
-					ipc_kmsg_clean_partial(kmsg, taddr,
-							       TRUE, i);
-					return MACH_SEND_INVALID_RIGHT;
-				}
-
-				if ((newname == MACH_MSG_TYPE_PORT_RECEIVE) &&
-				    ipc_port_check_circularity(
-							(ipc_port_t) object,
-							(ipc_port_t) dest))
-					kmsg->ikm_header.msgh_bits |=
-						MACH_MSGH_BITS_CIRCULAR;
-
-				objects[i] = object;
-			}
-
-			complex = TRUE;
-		}
-	}
-
-	if (complex)
-		kmsg->ikm_header.msgh_bits |= MACH_MSGH_BITS_COMPLEX;
-
-	return MACH_MSG_SUCCESS;
-}
-
-/*
- *	Routine:	ipc_kmsg_copyout_compat
- *	Purpose:
- *		"Copy-out" port rights and out-of-line memory
- *		in the message, producing an old IPC message.
- *
- *		Doesn't bother to handle the header atomically.
- *		Skips over errors.  Problem ports produce MACH_PORT_NULL
- *		(MACH_PORT_DEAD is never produced), and problem memory
- *		produces a zero address.
- *	Conditions:
- *		Nothing locked.
- *	Returns:
- *		MACH_MSG_SUCCESS	Copied out rights and memory.
- */
-
-mach_msg_return_t
-ipc_kmsg_copyout_compat(kmsg, space, map)
-	ipc_kmsg_t kmsg;
-	ipc_space_t space;
-	vm_map_t map;
-{
-	msg_header_t msg;
-	mach_msg_bits_t mbits = kmsg->ikm_header.msgh_bits;
-	ipc_object_t dest = (ipc_object_t) kmsg->ikm_header.msgh_remote_port;
-	ipc_object_t reply = (ipc_object_t) kmsg->ikm_header.msgh_local_port;
-	mach_port_t dest_name, reply_name;
-	vm_offset_t saddr, eaddr;
-	kern_return_t kr;
-
-	assert(IO_VALID(dest));
-
-	io_lock(dest);
-	if (io_active(dest)) {
-		mach_msg_type_name_t dest_type = MACH_MSGH_BITS_REMOTE(mbits);
-
-		ipc_object_copyout_dest(space, dest, dest_type, &dest_name);
-		/* dest is unlocked */
-	} else {
-		io_release(dest);
-		io_check_unlock(dest);
-		dest_name = MACH_PORT_NULL;
-	}
-
-	if (IO_VALID(reply)) {
-		mach_msg_type_name_t reply_type = MACH_MSGH_BITS_LOCAL(mbits);
-
-		kr = ipc_object_copyout_compat(space, reply, reply_type,
-					       &reply_name);
-		if (kr != KERN_SUCCESS) {
-			ipc_object_destroy(reply, reply_type);
-			reply_name = MACH_PORT_NULL;
-		}
-	} else
-		reply_name = MACH_PORT_NULL;
-
-	msg.msg_unused = 0;
-	msg.msg_simple = (mbits & MACH_MSGH_BITS_COMPLEX) ? FALSE : TRUE;
-	msg.msg_size = (msg_size_t) kmsg->ikm_header.msgh_size;
-	msg.msg_type = (integer_t) kmsg->ikm_header.msgh_seqno;
-	msg.msg_local_port = (port_name_t) dest_name;
-	msg.msg_remote_port = (port_name_t) reply_name;
-	msg.msg_id = (integer_t) kmsg->ikm_header.msgh_id;
-	* (msg_header_t *) &kmsg->ikm_header = msg;
-
-	if (msg.msg_simple)
-		return MACH_MSG_SUCCESS;
-
-	saddr = (vm_offset_t) (&kmsg->ikm_header + 1);
-	eaddr = (vm_offset_t) &kmsg->ikm_header + kmsg->ikm_header.msgh_size;
-
-	while (saddr < eaddr) {
-		vm_offset_t taddr = saddr;
-		mach_msg_type_long_t *type;
-		mach_msg_type_name_t name;
-		mach_msg_type_size_t size;
-		mach_msg_type_number_t number;
-		boolean_t is_inline, longform, is_port;
-		vm_size_t length;
-		vm_offset_t addr;
-
-		type = (mach_msg_type_long_t *) saddr;
-		is_inline = ((mach_msg_type_t*)type)->msgt_inline;
-		longform = ((mach_msg_type_t*)type)->msgt_longform;
-		if (longform) {
-			/* This must be aligned */
-			if ((sizeof(natural_t) > sizeof(mach_msg_type_t)) &&
-			    (is_misaligned(type))) {
-				saddr = ptr_align(saddr);
-				continue;
-			}
-			name = type->msgtl_name;
-			size = type->msgtl_size;
-			number = type->msgtl_number;
-			saddr += sizeof(mach_msg_type_long_t);
-		} else {
-			name = ((mach_msg_type_t*)type)->msgt_name;
-			size = ((mach_msg_type_t*)type)->msgt_size;
-			number = ((mach_msg_type_t*)type)->msgt_number;
-			saddr += sizeof(mach_msg_type_t);
-		}
-
-		/* padding (ptrs and ports) ? */
-		if ((sizeof(natural_t) > sizeof(mach_msg_type_t)) &&
-		    ((size >> 3) == sizeof(natural_t)))
-			saddr = ptr_align(saddr);
-
-		/* calculate length of data in bytes, rounding up */
-
-		length = ((number * size) + 7) >> 3;
-
-		is_port = MACH_MSG_TYPE_PORT_ANY(name);
-
-		if (is_port) {
-			mach_port_t *objects;
-			mach_msg_type_number_t i;
-			mach_msg_type_name_t newname;
-
-			if (!is_inline && (length != 0)) {
-				/* first allocate memory in the map */
-
-				kr = vm_allocate(map, &addr, length, TRUE);
-				if (kr != KERN_SUCCESS) {
-					ipc_kmsg_clean_body(taddr, saddr);
-					goto vm_copyout_failure;
-				}
-			}
-
-			newname = ipc_object_copyout_type_compat(name);
-			if (longform)
-				type->msgtl_name = newname;
-			else
-				((mach_msg_type_t*)type)->msgt_name = newname;
-
-			objects = (mach_port_t *)
-				(is_inline ? saddr : * (vm_offset_t *) saddr);
-
-			/* copyout port rights carried in the message */
-
-			for (i = 0; i < number; i++) {
-				ipc_object_t object =
-					(ipc_object_t) objects[i];
-
-				if (!IO_VALID(object)) {
-					objects[i] = MACH_PORT_NULL;
-					continue;
-				}
-
-				kr = ipc_object_copyout_compat(space, object,
-							name, &objects[i]);
-				if (kr != KERN_SUCCESS) {
-					ipc_object_destroy(object, name);
-					objects[i] = MACH_PORT_NULL;
-				}
-			}
-		}
-
-		if (is_inline) {
-			/* inline data sizes round up to int boundaries */
-
-			saddr += (length + 3) &~ 3;
-		} else {
-			vm_offset_t data = * (vm_offset_t *) saddr;
-
-			/* copyout memory carried in the message */
-
-			if (length == 0) {
-				assert(data == 0);
-				addr = 0;
-			} else if (is_port) {
-				/* copyout to memory allocated above */
-
-				(void) copyoutmap(map, (char *) data,
-						  (char *) addr, length);
-				kfree(data, length);
-			} else {
-				vm_map_copy_t copy = (vm_map_copy_t) data;
-
-				kr = vm_map_copyout(map, &addr, copy);
-				if (kr != KERN_SUCCESS) {
-					vm_map_copy_discard(copy);
-
-				    vm_copyout_failure:
-
-					addr = 0;
-				}
-			}
-
-			* (vm_offset_t *) saddr = addr;
-			saddr += sizeof(vm_offset_t);
-		}
-	}
-
-	return MACH_MSG_SUCCESS;
-}
-
-#endif	/* MACH_IPC_COMPAT */
-
 #include <mach_kdb.h>
 #if	MACH_KDB
 
diff -Npur gnumach.old/ipc/ipc_kmsg.h gnumach.new/ipc/ipc_kmsg.h
--- gnumach.old/ipc/ipc_kmsg.h	2006-03-20 08:31:36.000000000 -0300
+++ gnumach.new/ipc/ipc_kmsg.h	2006-04-05 13:36:37.000000000 -0300
@@ -35,7 +35,6 @@
 #define _IPC_IPC_KMSG_H_
 
 #include <cpus.h>
-#include <mach_ipc_compat.h>
 
 #include <mach/machine/vm_types.h>
 #include <mach/message.h>
@@ -269,13 +268,4 @@ ipc_kmsg_copyout_pseudo(/* ipc_kmsg_t, i
 extern void
 ipc_kmsg_copyout_dest(/* ipc_kmsg_t, ipc_space_t */);
 
-#if	MACH_IPC_COMPAT
-
-extern mach_msg_return_t
-ipc_kmsg_copyin_compat(/* ipc_kmsg_t, ipc_space_t, vm_map_t */);
-
-extern mach_msg_return_t
-ipc_kmsg_copyout_compat(/* ipc_kmsg_t, ipc_space_t, vm_map_t */);
-
-#endif	/* MACH_IPC_COMPAT */
 #endif	/* _IPC_IPC_KMSG_H_ */
diff -Npur gnumach.old/ipc/ipc_marequest.c gnumach.new/ipc/ipc_marequest.c
--- gnumach.old/ipc/ipc_marequest.c	2001-04-05 03:39:19.000000000 -0300
+++ gnumach.new/ipc/ipc_marequest.c	2006-04-05 13:27:13.000000000 -0300
@@ -34,8 +34,6 @@
  *	Functions to handle msg-accepted requests.
  */
 
-#include <mach_ipc_compat.h>
-
 #include <mach/message.h>
 #include <mach/port.h>
 #include <kern/lock.h>
@@ -160,9 +158,6 @@ ipc_marequest_init()
  *
  *		The "notify" argument should name a receive right
  *		that is used to create the send-once notify port.
- *
- *		[MACH_IPC_COMPAT] If "notify" is MACH_PORT_NULL,
- *		then an old-style msg-accepted request is created.
  *	Conditions:
  *		Nothing locked; refs held for space and port.
  *	Returns:
@@ -187,10 +182,6 @@ ipc_marequest_create(space, port, notify
 	ipc_marequest_t marequest;
 	ipc_marequest_bucket_t bucket;
 
-#if	!MACH_IPC_COMPAT
-	assert(notify != MACH_PORT_NULL);
-#endif	/* !MACH_IPC_COMPAT */
-
 	marequest = imar_alloc();
 	if (marequest == IMAR_NULL)
 		return MACH_SEND_NO_NOTIFY;
@@ -225,11 +216,6 @@ ipc_marequest_create(space, port, notify
 			return MACH_SEND_NOTIFY_IN_PROGRESS;
 		}
 
-#if	MACH_IPC_COMPAT
-		if (notify == MACH_PORT_NULL)
-			soright = IP_NULL;
-		else
-#endif	/* MACH_IPC_COMPAT */
 		if ((soright = ipc_port_lookup_notify(space, notify))
 								== IP_NULL) {
 			is_write_unlock(space);
@@ -252,11 +238,6 @@ ipc_marequest_create(space, port, notify
 
 		imarb_unlock(bucket);
 	} else {
-#if	MACH_IPC_COMPAT
-		if (notify == MACH_PORT_NULL)
-			soright = IP_NULL;
-		else
-#endif	/* MACH_IPC_COMPAT */
 		if ((soright = ipc_port_lookup_notify(space, notify))
 								== IP_NULL) {
 			is_write_unlock(space);
@@ -371,9 +352,6 @@ ipc_marequest_destroy(marequest)
 	ipc_space_t space = marequest->imar_space;
 	mach_port_t name;
 	ipc_port_t soright;
-#if	MACH_IPC_COMPAT
-	ipc_port_t sright = IP_NULL;
-#endif	/* MACH_IPC_COMPAT */
 
 	is_write_lock(space);
 
@@ -408,10 +386,6 @@ ipc_marequest_destroy(marequest)
 
 			entry->ie_bits &= ~IE_BITS_MAREQUEST;
 
-#if	MACH_IPC_COMPAT
-			if (soright == IP_NULL)
-				sright = ipc_space_make_notify(space);
-#endif	/* MACH_IPC_COMPAT */
 		} else
 			name = MACH_PORT_NULL;
 	}
@@ -421,18 +395,6 @@ ipc_marequest_destroy(marequest)
 
 	imar_free(marequest);
 
-#if	MACH_IPC_COMPAT
-	if (soright == IP_NULL) {
-		if (IP_VALID(sright)) {
-			assert(name != MACH_PORT_NULL);
-			ipc_notify_msg_accepted_compat(sright, name);
-		}
-
-		return;
-	}
-	assert(sright == IP_NULL);
-#endif	/* MACH_IPC_COMPAT */
-
 	assert(soright != IP_NULL);
 	ipc_notify_msg_accepted(soright, name);
 }
diff -Npur gnumach.old/ipc/ipc_notify.c gnumach.new/ipc/ipc_notify.c
--- gnumach.old/ipc/ipc_notify.c	2006-03-20 08:31:36.000000000 -0300
+++ gnumach.new/ipc/ipc_notify.c	2006-04-05 13:25:47.000000000 -0300
@@ -31,8 +31,6 @@
  *	Notification-sending functions.
  */
 
-#include <mach_ipc_compat.h>
-
 #include <mach/port.h>
 #include <mach/message.h>
 #include <mach/notify.h>
@@ -51,19 +49,7 @@ mach_no_senders_notification_t		ipc_noti
 mach_send_once_notification_t		ipc_notify_send_once_template;
 mach_dead_name_notification_t		ipc_notify_dead_name_template;
 
-#if	MACH_IPC_COMPAT
-/*
- *	When notification messages are received via the old
- *	msg_receive trap, the msg_type field should contain
- *	MSG_TYPE_EMERGENCY.  We arrange for this by putting
- *	MSG_TYPE_EMERGENCY into msgh_seqno, which
- *	ipc_kmsg_copyout_compat copies to msg_type.
- */
-
-#define NOTIFY_MSGH_SEQNO	MSG_TYPE_EMERGENCY
-#else	/* MACH_IPC_COMPAT */
 #define NOTIFY_MSGH_SEQNO	0
-#endif	/* MACH_IPC_COMPAT */
 
 /*
  *	Routine:	ipc_notify_init_port_deleted
@@ -464,123 +450,3 @@ ipc_notify_dead_name(port, name)
 
 	ipc_mqueue_send_always(kmsg);
 }
-
-#if	MACH_IPC_COMPAT
-
-/*
- *	Routine:	ipc_notify_port_deleted_compat
- *	Purpose:
- *		Send a port-deleted notification.
- *		Sends it to a send right instead of a send-once right.
- *	Conditions:
- *		Nothing locked.
- *		Consumes a ref/sright for port.
- */
-
-void
-ipc_notify_port_deleted_compat(port, name)
-	ipc_port_t port;
-	mach_port_t name;
-{
-	ipc_kmsg_t kmsg;
-	mach_port_deleted_notification_t *n;
-
-	kmsg = ikm_alloc(sizeof *n);
-	if (kmsg == IKM_NULL) {
-		printf("dropped port-deleted-compat (0x%08x, 0x%x)\n",
-		       port, name);
-		ipc_port_release_send(port);
-		return;
-	}
-
-	ikm_init(kmsg, sizeof *n);
-	n = (mach_port_deleted_notification_t *) &kmsg->ikm_header;
-	*n = ipc_notify_port_deleted_template;
-
-	n->not_header.msgh_bits = MACH_MSGH_BITS(MACH_MSG_TYPE_PORT_SEND, 0);
-	n->not_header.msgh_remote_port = (mach_port_t) port;
-	n->not_port = name;
-
-	ipc_mqueue_send_always(kmsg);
-}
-
-/*
- *	Routine:	ipc_notify_msg_accepted_compat
- *	Purpose:
- *		Send a msg-accepted notification.
- *		Sends it to a send right instead of a send-once right.
- *	Conditions:
- *		Nothing locked.
- *		Consumes a ref/sright for port.
- */
-
-void
-ipc_notify_msg_accepted_compat(port, name)
-	ipc_port_t port;
-	mach_port_t name;
-{
-	ipc_kmsg_t kmsg;
-	mach_msg_accepted_notification_t *n;
-
-	kmsg = ikm_alloc(sizeof *n);
-	if (kmsg == IKM_NULL) {
-		printf("dropped msg-accepted-compat (0x%08x, 0x%x)\n",
-		       port, name);
-		ipc_port_release_send(port);
-		return;
-	}
-
-	ikm_init(kmsg, sizeof *n);
-	n = (mach_msg_accepted_notification_t *) &kmsg->ikm_header;
-	*n = ipc_notify_msg_accepted_template;
-
-	n->not_header.msgh_bits = MACH_MSGH_BITS(MACH_MSG_TYPE_PORT_SEND, 0);
-	n->not_header.msgh_remote_port = (mach_port_t) port;
-	n->not_port = name;
-
-	ipc_mqueue_send_always(kmsg);
-}
-
-/*
- *	Routine:	ipc_notify_port_destroyed_compat
- *	Purpose:
- *		Send a port-destroyed notification.
- *		Sends it to a send right instead of a send-once right.
- *	Conditions:
- *		Nothing locked.
- *		Consumes a ref/sright for port.
- *		Consumes a ref for right, which should be a receive right
- *		prepped for placement into a message.  (In-transit,
- *		or in-limbo if a circularity was detected.)
- */
-
-void
-ipc_notify_port_destroyed_compat(port, right)
-	ipc_port_t port;
-	ipc_port_t right;
-{
-	ipc_kmsg_t kmsg;
-	mach_port_destroyed_notification_t *n;
-
-	kmsg = ikm_alloc(sizeof *n);
-	if (kmsg == IKM_NULL) {
-		printf("dropped port-destroyed-compat (0x%08x, 0x%08x)\n",
-		       port, right);
-		ipc_port_release_send(port);
-		ipc_port_release_receive(right);
-		return;
-	}
-
-	ikm_init(kmsg, sizeof *n);
-	n = (mach_port_destroyed_notification_t *) &kmsg->ikm_header;
-	*n = ipc_notify_port_destroyed_template;
-
-	n->not_header.msgh_bits = MACH_MSGH_BITS_COMPLEX |
-		MACH_MSGH_BITS(MACH_MSG_TYPE_PORT_SEND, 0);
-	n->not_header.msgh_remote_port = (mach_port_t) port;
-	n->not_port = (mach_port_t) right;
-
-	ipc_mqueue_send_always(kmsg);
-}
-
-#endif	/* MACH_IPC_COMPAT */
diff -Npur gnumach.old/ipc/ipc_notify.h gnumach.new/ipc/ipc_notify.h
--- gnumach.old/ipc/ipc_notify.h	2001-04-05 03:39:19.000000000 -0300
+++ gnumach.new/ipc/ipc_notify.h	2006-04-05 13:24:58.000000000 -0300
@@ -34,8 +34,6 @@
 #ifndef	_IPC_IPC_NOTIFY_H_
 #define _IPC_IPC_NOTIFY_H_
 
-#include <mach_ipc_compat.h>
-
 extern void
 ipc_notify_init();
 
@@ -57,16 +55,4 @@ ipc_notify_send_once(/* ipc_port_t */);
 extern void
 ipc_notify_dead_name(/* ipc_port_t, mach_port_t */);
 
-#if	MACH_IPC_COMPAT
-
-extern void
-ipc_notify_port_deleted_compat(/* ipc_port_t, mach_port_t */);
-
-extern void
-ipc_notify_msg_accepted_compat(/* ipc_port_t, mach_port_t */);
-
-extern void
-ipc_notify_port_destroyed_compat(/* ipc_port_t, ipc_port_t */);
-
-#endif	/* MACH_IPC_COMPAT */
 #endif	/* _IPC_IPC_NOTIFY_H_ */
